6 ALWAYS_EXCEPT="52 $RECOVERY_SMALL_EXCEPT"
8 export MULTIOP=${MULTIOP:-multiop}
9 PTLDEBUG=${PTLDEBUG:--1}
10 LUSTRE=${LUSTRE:-`dirname $0`/..}
11 . $LUSTRE/tests/test-framework.sh
13 . ${CONFIG:=$LUSTRE/tests/cfg/$NAME.sh}
16 require_dsh_mds || exit 0
18 # also long tests: 19, 21a, 21e, 21f, 23, 27
20 [ "$SLOW" = "no" ] && EXCEPT_SLOW=""
24 # Allow us to override the setup if we already have a mounted system by
25 # setting SETUP=" " and CLEANUP=" "
27 CLEANUP=${CLEANUP:-""}
29 check_and_setup_lustre
32 rm -rf $DIR/d[0-9]* $DIR/f.${TESTSUITE}*
35 local f1="$DIR/$tfile"
36 local f2="$DIR/$tfile.2"
38 drop_request "mcreate $f1" ||
39 error_noexit "create '$f1': drop req"
41 drop_reint_reply "mcreate $f2" ||
42 error_noexit "create '$f2': drop rep"
44 drop_request "tchmod 111 $f2" ||
45 error_noexit "chmod '$f2': drop req"
47 drop_reint_reply "tchmod 666 $f2" ||
48 error_noexit "chmod '$f2': drop rep"
50 drop_request "statone $f2" ||
51 error_noexit "stat '$f2': drop req"
53 drop_reply "statone $f2" ||
54 error_noexit "stat '$f2': drop rep"
56 run_test 1 "create, chmod, stat: drop req, drop rep"
60 do_facet_create_file client $t 10K ||
61 error_noexit "Create file $t"
63 drop_request "cat $t > /dev/null" ||
64 error_noexit "Open request for $t file"
66 drop_reply "cat $t > /dev/null" ||
67 error_noexit "Open replay for $t file"
69 run_test 4 "open: drop req, drop rep"
74 local RR="$T-renamed-again"
75 do_facet_create_file client $T 10K ||
76 error_noexit "Create file $T"
78 drop_request "mv $T $R" ||
79 error_noexit "Rename $T"
81 drop_reint_reply "mv $R $RR" ||
82 error_noexit "Failed rename replay on $R"
84 do_facet client "checkstat -v $RR" ||
85 error_noexit "checkstat error on $RR"
87 do_facet client "rm $RR" ||
88 error_noexit "Can't remove file $RR"
90 run_test 5 "rename: drop req, drop rep"
94 local LINK1=$DIR/$tfile.link1
95 local LINK2=$DIR/$tfile.link2
97 do_facet_create_file client $T 10K ||
98 error_noexit "Create file $T"
100 drop_request "mlink $T $LINK1" ||
101 error_noexit "mlink request for $T"
103 drop_reint_reply "mlink $T $LINK2" ||
104 error_noexit "mlink reply for $T"
106 drop_request "munlink $LINK1" ||
107 error_noexit "munlink request for $T"
109 drop_reint_reply "munlink $LINK2" ||
110 error_noexit "munlink reply for $T"
112 do_facet client "rm $T" ||
113 error_noexit "Can't remove file $T"
115 run_test 6 "link, unlink: drop req, drop rep"
119 drop_reint_reply "touch $DIR/$tfile" || return 1
121 run_test 8 "touch: drop rep (bug 1423)"
125 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
129 do_facet_random_file client $TMP/$tfile 1K ||
130 error_noexit "Create random file $TMP/$tfile"
131 # make this big, else test 9 doesn't wait for bulk -- bz 5595
132 do_facet_create_file client $TMP/$t1 4M ||
133 error_noexit "Create file $TMP/$t1"
134 do_facet client "cp $TMP/$t1 $DIR/$t1" ||
135 error_noexit "Can't copy to $DIR/$t1 file"
136 pause_bulk "cp $TMP/$tfile $DIR/$tfile" ||
137 error_noexit "Can't pause_bulk copy"
138 do_facet client "cp $TMP/$t1 $DIR/$t2" ||
139 error_noexit "Can't copy file"
140 do_facet client "sync"
141 do_facet client "rm $DIR/$tfile $DIR/$t2 $DIR/$t1" ||
142 error_noexit "Can't remove files"
143 do_facet client "rm $TMP/$t1 $TMP/$tfile"
145 run_test 9 "pause bulk on OST (bug 1420)"
149 local before=$(date +%s)
152 do_facet client "stat $DIR > /dev/null" ||
153 error "failed to stat $DIR: $?"
154 drop_bl_callback "chmod 0777 $DIR" ||
155 error "failed to chmod $DIR: $?"
157 # let the client reconnect
159 evict=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
160 awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
161 [ ! -z "$evict" ] && [[ $evict -gt $before ]] ||
162 (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
163 error "no eviction: $evict before:$before")
165 do_facet client checkstat -v -p 0777 $DIR ||
166 error "client checkstat failed: $?"
168 run_test 10a "finish request on server after client eviction (bug 1521)"
171 local before=$(date +%s)
174 [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.53) ]] &&
175 skip "Need MDS version at least 2.6.53" && return
176 do_facet client "stat $DIR > /dev/null" ||
177 error "failed to stat $DIR: $?"
178 drop_bl_callback_once "chmod 0777 $DIR" ||
179 error "failed to chmod $DIR: $?"
181 # let the client reconnect
183 evict=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
184 awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
186 [ -z "$evict" ] || [[ $evict -le $before ]] ||
187 (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
188 error "eviction happened: $evict before:$before")
190 do_facet client checkstat -v -p 0777 $DIR ||
191 error "client checkstat failed: $?"
193 run_test 10b "re-send BL AST"
196 local before=$(date +%s)
205 workdir="${DIR}/${tdir}"
206 mkdir -p ${workdir} || error "can't create workdir $?"
207 stat ${workdir} > /dev/null ||
208 error "failed to stat ${workdir}: $?"
209 mdtidx=$($LFS getdirstripe -i ${workdir})
210 mdtname=$($LFS mdts ${workdir} | grep -e "^$mdtidx:" |
211 awk '{sub("_UUID", "", $2); print $2;}')
213 mdccli=$($LCTL dl | grep "${mdtname}-mdc" | awk '{print $4;}')
214 conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
215 mdcpath="mdc.${mdccli}.import=connection=${conn_uuid}"
217 drop_bl_callback_once "chmod 0777 ${workdir}" &
222 # force client reconnect
223 $LCTL set_param "${mdcpath}"
225 # wait client reconnect
229 evict=$($LCTL get_param mdc.${mdccli}.state |
230 awk -F"[ [,]" '/EVICTED]$/ { if (t<$4) {t=$4;} } END { print t }')
232 [[ $evict -le $before ]] ||
233 ( $LCTL get_param mdc.$FSNAME-MDT*.state;
234 error "eviction happened: $EVICT before:$BEFORE" )
236 [ $rc -eq 0 ] || error "chmod must finished OK"
237 checkstat -v -p 0777 "${workdir}" ||
238 error "client checkstat failed: $?"
240 run_test 10c "re-send BL AST vs reconnect race (LU-5569)"
243 local before=$(date +%s)
246 [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.90) ]] &&
247 skip "Need MDS version at least 2.6.90" && return
249 # sleep 1 is to make sure that BEFORE is not equal to EVICTED below
252 echo -n ", world" | dd of=$TMP/$tfile bs=1c seek=5
254 remount_client $MOUNT
258 $LFS setstripe -i 0 -c 1 $DIR1/$tfile
259 echo -n hello | dd of=$DIR1/$tfile bs=5
261 stat $DIR2/$tfile >& /dev/null
262 $LCTL set_param fail_err=71
263 drop_bl_callback "echo -n \\\", world\\\" >> $DIR2/$tfile"
268 cmp -l $DIR1/$tfile $DIR2/$tfile || error "file contents differ"
269 cmp -l $DIR1/$tfile $TMP/$tfile || error "wrong content found"
271 evict=$(do_facet client $LCTL get_param osc.$FSNAME-OST0000*.state | \
273 awk -F"[ [,]" '/EVICTED$/ { if (mx<$1) {mx=$1;} } END { print mx }')
275 [[ $evict -gt $before ]] ||
276 (do_facet client $LCTL get_param osc.$FSNAME-OST0000*.state;
277 error "no eviction: $evict before:$before")
279 $LCTL set_param fail_err=0
281 umount_client $MOUNT2
283 run_test 10d "test failed blocking ast"
287 [[ $(lustre_version_code ost1) -le $(version_code 2.8.58) ]] &&
288 skip "Need OST version at least 2.8.59" && return 0
289 [ $CLIENTCOUNT -lt 2 ] && skip "need two clients" && return 0
290 [ $(facet_host client) == $(facet_host ost1) ] &&
291 skip "need ost1 and client on different nodes" && return 0
292 local -a clients=(${CLIENTS//,/ })
293 local client1=${clients[0]}
294 local client2=${clients[1]}
296 $LFS setstripe -c 1 -i 0 $DIR/$tfile-1 $DIR/$tfile-2
297 $MULTIOP $DIR/$tfile-1 Ow1048576c
299 #define OBD_FAIL_LDLM_BL_CALLBACK_NET 0x305
300 $LCTL set_param fail_loc=0x80000305
302 #define OBD_FAIL_LDLM_ENQUEUE_OLD_EXPORT 0x30e
303 do_facet ost1 "$LCTL set_param fail_loc=0x1000030e"
304 # hit OBD_FAIL_LDLM_ENQUEUE_OLD_EXPORT twice:
305 # 1. to return ENOTCONN from ldlm_handle_enqueue0
306 # 2. to pause reconnect handling between resend and setting
307 # import to LUSTRE_IMP_FULL state
308 do_facet ost1 "$LCTL set_param fail_val=3"
310 # client1 fails ro respond to bl ast
311 do_node $client2 "$MULTIOP $DIR/$tfile-1 Ow1048576c" &
314 # ost1 returns error on enqueue, which causes client1 to reconnect
315 do_node $client1 "$MULTIOP $DIR/$tfile-2 Ow1048576c" ||
316 error "multiop failed"
319 do_facet ost1 "$LCTL set_param fail_loc=0"
320 do_facet ost1 "$LCTL set_param fail_val=0"
322 run_test 10e "re-send BL AST vs reconnect race 2"
325 # wake up a thread waiting for completion after eviction
327 do_facet client $MULTIOP $DIR/$tfile Ow ||
328 { error "multiop write failed: $?"; return 1; }
329 do_facet client $MULTIOP $DIR/$tfile or ||
330 { error "multiop read failed: $?"; return 2; }
334 do_facet client $MULTIOP $DIR/$tfile or ||
335 { error "multiop read failed: $?"; return 3; }
336 drop_bl_callback_once $MULTIOP $DIR/$tfile Ow ||
337 echo "evicted as expected"
339 do_facet client munlink $DIR/$tfile ||
340 { error "munlink failed: $?"; return 4; }
341 # allow recovery to complete
342 client_up || client_up || sleep $TIMEOUT
344 run_test 11 "wake up a thread waiting for completion after eviction (b=2460)"
348 $LCTL mark $MULTIOP $DIR/$tfile OS_c
349 do_facet $SINGLEMDS "lctl set_param fail_loc=0x115"
350 clear_failloc $SINGLEMDS $((TIMEOUT * 2)) &
351 multiop_bg_pause $DIR/$tfile OS_c ||
352 { error "multiop failed: $?"; return 1; }
354 #define OBD_FAIL_MDS_CLOSE_NET 0x115
356 echo "waiting for multiop $PID"
357 wait $PID || { error "wait for multiop faile: $?"; return 2; }
358 do_facet client munlink $DIR/$tfile ||
359 { error "client munlink failed: $?"; return 3; }
360 # allow recovery to complete
361 client_up || client_up || sleep $TIMEOUT
363 run_test 12 "recover from timed out resend in ptlrpcd (b=2494)"
365 # Bug 113, check that readdir lost recv timeout works.
367 mkdir -p $DIR/$tdir || { error "mkdir failed: $?"; return 1; }
368 touch $DIR/$tdir/newentry || { error "touch failed: $?"; return 2; }
369 # OBD_FAIL_MDS_READPAGE_NET|OBD_FAIL_ONCE
370 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000104"
371 ls $DIR/$tdir || { error "ls failed: $?"; return 3; }
372 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
373 rm -rf $DIR/$tdir || { error "remove test dir failed: $?"; return 4; }
375 run_test 13 "mdc_readpage restart test (bug 1138)"
377 # Bug 113, check that readdir lost send timeout works.
380 touch $DIR/$tdir/newentry
381 # OBD_FAIL_MDS_SENDPAGE|OBD_FAIL_ONCE
382 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000106"
383 ls $DIR/$tdir || return 1
384 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
386 run_test 14 "mdc_readpage resend test (bug 1138)"
389 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000128"
390 touch $DIR/$tfile && return 1
393 run_test 15 "failed open (-ENOMEM)"
395 READ_AHEAD=`lctl get_param -n llite.*.max_read_ahead_mb | head -n 1`
397 lctl set_param -n llite.*.max_read_ahead_mb 0
401 lctl set_param -n llite.*.max_read_ahead_mb $READ_AHEAD
405 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
407 do_facet_random_file client $TMP/$tfile 100K ||
408 { error_noexit "Create random file $TMP/$T" ; return 0; }
409 do_facet client "cp $TMP/$tfile $DIR/$tfile" ||
410 { error_noexit "Copy to $DIR/$tfile file" ; return 0; }
414 #define OBD_FAIL_PTLRPC_BULK_PUT_NET 0x504 | OBD_FAIL_ONCE
415 do_facet ost1 "lctl set_param fail_loc=0x80000504"
417 # OST bulk will time out here, client resends
418 do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 1
419 do_facet ost1 lctl set_param fail_loc=0
420 # give recovery a chance to finish (shouldn't take long)
422 do_facet client "cmp $TMP/$tfile $DIR/$tfile" || return 2
426 run_test 16 "timeout bulk put, don't evict client (2732)"
431 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
433 local SAMPLE_FILE=$TMP/$tfile
434 do_facet_random_file client $SAMPLE_FILE 20K ||
435 { error_noexit "Create random file $SAMPLE_FILE" ; return 0; }
437 # With adaptive timeouts, bulk_get won't expire until adaptive_timeout_max
438 if at_is_enabled; then
439 at_max_saved=$(at_max_get ost1)
440 at_max_set $TIMEOUT ost1
443 # OBD_FAIL_PTLRPC_BULK_GET_NET 0x0503 | OBD_FAIL_ONCE
444 # OST bulk will time out here, client retries
445 do_facet ost1 lctl set_param fail_loc=0x80000503
446 # need to ensure we send an RPC
447 do_facet client cp $SAMPLE_FILE $DIR/$tfile
450 # with AT, client will wait adaptive_max*factor+net_latency before
451 # expiring the req, hopefully timeout*2 is enough
452 sleep $(($TIMEOUT*2))
454 do_facet ost1 lctl set_param fail_loc=0
455 do_facet client "df $DIR"
456 # expect cmp to succeed, client resent bulk
457 do_facet client "cmp $SAMPLE_FILE $DIR/$tfile" || return 3
458 do_facet client "rm $DIR/$tfile" || return 4
459 [ $at_max_saved -ne 0 ] && at_max_set $at_max_saved ost1
462 run_test 17a "timeout bulk get, don't evict client (2732)"
465 [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
467 # get one of the clients from client list
468 local rcli=$(echo $RCLIENTS | cut -d ' ' -f 1)
469 local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
470 local ldlm_enqueue_min=$(do_facet ost1 find /sys -name ldlm_enqueue_min)
471 [ -z "$ldlm_enqueue_min" ] &&
472 skip "missing /sys/.../ldlm_enqueue_min" && return 0
474 $LFS setstripe -i 0 -c 1 -S 1048576 $DIR/$tfile ||
475 error "setstripe failed"
476 $LFS setstripe -i 0 -c 1 -S 1048576 $DIR/${tfile}2 ||
477 error "setstripe 2 failed"
479 save_lustre_params ost1 "at_history" > $p
480 save_lustre_params ost1 "bulk_timeout" >> $p
481 local dev="${FSNAME}-OST0000"
482 save_lustre_params ost1 "obdfilter.$dev.brw_size" >> $p
483 local ldlm_enqueue_min_save=$(do_facet ost1 cat $ldlm_enqueue_min)
485 local new_at_history=15
487 do_facet ost1 "$LCTL set_param at_history=$new_at_history"
488 do_facet ost1 "$LCTL set_param bulk_timeout=30"
489 do_facet ost1 "echo 30 > /sys/module/ptlrpc/parameters/ldlm_enqueue_min"
491 # brw_size is required to be 4m so that bulk transfer timeout
492 # could be simulated with OBD_FAIL_PTLRPC_CLIENT_BULK_CB3
493 local brw_size=$($LCTL get_param -n \
494 osc.$FSNAME-OST0000-osc-[^M]*.import |
495 awk '/max_brw_size/{print $2}')
496 if [ $brw_size -ne 4194304 ]
498 save_lustre_params ost1 "obdfilter.$dev.brw_size" >> $p
499 do_facet ost1 "$LCTL set_param obdfilter.$dev.brw_size=4"
500 remount_client $MOUNT
503 # get service estimate expanded
504 #define OBD_FAIL_OST_BRW_PAUSE_PACK 0x224
505 do_facet ost1 "$LCTL set_param fail_loc=0x80000224 fail_val=35"
506 echo "delay rpc servicing by 35 seconds"
507 dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 conv=fdatasync
510 estimate=$($LCTL get_param -n osc.$dev-osc-*.timeouts |
511 awk '/portal 6/ {print $5}')
512 echo "service estimates increased to $estimate"
514 # let current worst service estimate to get closer to obliteration
515 sleep $((new_at_history / 3))
517 # start i/o and simulate bulk transfer loss
518 #define OBD_FAIL_PTLRPC_CLIENT_BULK_CB3 0x520
519 do_facet ost1 "$LCTL set_param fail_loc=0xa0000520 fail_val=1"
520 dd if=/dev/zero of=$DIR/$tfile bs=2M count=1 conv=fdatasync,notrunc &
523 # start lock conflict handling
524 sleep $((new_at_history / 3))
525 do_node $rcli "dd if=$DIR/$tfile of=/dev/null bs=1M count=1" &
528 # obliterate the worst service estimate
529 sleep $((new_at_history / 3 + 1))
530 dd if=/dev/zero of=$DIR/${tfile}2 bs=1M count=1
532 estimate=$($LCTL get_param -n osc.$dev-osc-*.timeouts |
533 awk '/portal 6/ {print $5}')
534 echo "service estimate dropped to $estimate"
537 [[ $? == 0 ]] || error "write failed"
539 [[ $? == 0 ]] || error "read failed"
541 restore_lustre_params <$p
542 if [ $brw_size -ne 4194304 ]
544 remount_client $MOUNT || error "remount_client failed"
546 do_facet ost1 "echo $ldlm_enqueue_min_save > $ldlm_enqueue_min"
548 run_test 17b "timeout bulk get, dont evict client (3582)"
551 [ -z ${ost2_svc} ] && skip_env "needs 2 osts" && return 0
553 do_facet_create_file client $TMP/$tfile 20K ||
554 { error_noexit "Create file $TMP/$tfile" ; return 0; }
556 do_facet client mkdir -p $DIR/$tdir
560 pgcache_empty || return 1
563 $LFS setstripe -i 1 -c 1 $f
564 stripe_index=$($LFS getstripe -i $f)
565 if [ $stripe_index -ne 1 ]; then
567 error "$f: stripe_index $stripe_index != 1" && return
570 do_facet client cp $TMP/$tfile $f
572 local osc2dev=`lctl get_param -n devices | grep ${ost2_svc}-osc- | egrep -v 'MDT' | awk '{print $1}'`
573 $LCTL --device $osc2dev deactivate || return 3
574 # my understanding is that there should be nothing in the page
575 # cache after the client reconnects?
577 pgcache_empty || rc=2
578 $LCTL --device $osc2dev activate
582 run_test 18a "manual ost invalidate clears page cache immediately"
585 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
587 do_facet_create_file client $TMP/$tfile 20K ||
588 { error_noexit "Create file $TMP/$tfile" ; return 0; }
590 do_facet client mkdir -p $DIR/$tdir
594 pgcache_empty || return 1
596 $LFS setstripe -i 0 -c 1 $f
597 stripe_index=$($LFS getstripe -i $f)
598 if [ $stripe_index -ne 0 ]; then
600 error "$f: stripe_index $stripe_index != 0" && return
603 do_facet client cp $TMP/$tfile $f
606 # allow recovery to complete
607 sleep $((TIMEOUT + 2))
608 # my understanding is that there should be nothing in the page
609 # cache after the client reconnects?
611 pgcache_empty || rc=2
615 run_test 18b "eviction and reconnect clears page cache (2766)"
618 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
620 do_facet_create_file client $TMP/$tfile 20K ||
621 { error_noexit "Create file $TMP/$tfile" ; return 0; }
623 do_facet client mkdir -p $DIR/$tdir
627 pgcache_empty || return 1
629 $LFS setstripe -i 0 -c 1 $f
630 stripe_index=$($LFS getstripe -i $f)
631 if [ $stripe_index -ne 0 ]; then
633 error "$f: stripe_index $stripe_index != 0" && return
636 do_facet client cp $TMP/$tfile $f
640 # OBD_FAIL_OST_CONNECT_NET2
641 # lost reply to connect request
642 do_facet ost1 lctl set_param fail_loc=0x80000225
645 $LFS df $MOUNT > /dev/null 2>&1
647 # my understanding is that there should be nothing in the page
648 # cache after the client reconnects?
650 pgcache_empty || rc=2
654 run_test 18c "Dropped connect reply after eviction handing (14755)"
657 local BEFORE=`date +%s`
660 mount_client $DIR2 || error "failed to mount $DIR2"
662 # cancel cached locks from OST to avoid eviction from it
665 do_facet client "stat $DIR > /dev/null" ||
666 error "failed to stat $DIR: $?"
667 drop_ldlm_cancel "chmod 0777 $DIR2" ||
668 error "failed to chmod $DIR2"
672 # let the client reconnect
674 EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
675 awk -F"[ [,]" '/EVICTED ]$/ \
676 { if (mx<$5) {mx=$5;} } END { print mx }')
678 [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] ||
679 (do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state;
680 error "no eviction: $EVICT before:$BEFORE")
682 run_test 19a "test expired_lock_main on mds (2867)"
685 local BEFORE=`date +%s`
688 mount_client $DIR2 || error "failed to mount $DIR2: $?"
690 # cancel cached locks from MDT to avoid eviction from it
693 do_facet client $MULTIOP $DIR/$tfile Ow ||
694 error "failed to run multiop: $?"
695 drop_ldlm_cancel $MULTIOP $DIR2/$tfile Ow ||
696 error "failed to ldlm_cancel: $?"
698 umount_client $DIR2 || error "failed to unmount $DIR2: $?"
699 do_facet client munlink $DIR/$tfile ||
700 error "failed to unlink $DIR/$tfile: $?"
702 # let the client reconnect
704 EVICT=$(do_facet client $LCTL get_param osc.$FSNAME-OST*.state |
705 awk -F"[ [,]" '/EVICTED ]$/ \
706 { if (mx < $5) {mx = $5;} } END { print mx }')
708 [ ! -z "$EVICT" ] && [[ $EVICT -gt $BEFORE ]] ||
709 (do_facet client $LCTL get_param osc.$FSNAME-OST*.state;
710 error "no eviction: $EVICT before:$BEFORE")
712 run_test 19b "test expired_lock_main on ost (2867)"
715 local BEFORE=`date +%s`
718 $LCTL set_param ldlm.namespaces.*.early_lock_cancel=0
720 mkdir -p $DIR1/$tfile
723 #define OBD_FAIL_PTLRPC_CANCEL_RESEND 0x516
724 do_facet mds $LCTL set_param fail_loc=0x80000516
726 touch $DIR2/$tfile/file1 &
728 # let touch to get blocked on the server
732 $LCTL set_param ldlm.namespaces.*.early_lock_cancel=1
735 # let the client reconnect
737 EVICT=$(do_facet client $LCTL get_param mdc.$FSNAME-MDT*.state |
738 awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
740 [ -z "$EVICT" ] || [[ $EVICT -le $BEFORE ]] || error "eviction happened"
742 run_test 19c "check reconnect and lock resend do not trigger expired_lock_main"
744 test_20a() { # bug 2983 - ldlm_handle_enqueue cleanup
745 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
748 $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
749 multiop_bg_pause $DIR/$tdir/${tfile} O_wc || return 1
752 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
753 do_facet ost1 lctl set_param fail_loc=0x80000308
754 kill -USR1 $MULTI_PID
757 [ $rc -eq 0 ] && error "multiop didn't fail enqueue: rc $rc" || true
759 run_test 20a "ldlm_handle_enqueue error (should return error)"
761 test_20b() { # bug 2986 - ldlm_handle_enqueue error during open
762 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
765 $LFS setstripe -i 0 -c 1 $DIR/$tdir/${tfile}
767 #define OBD_FAIL_LDLM_ENQUEUE_EXTENT_ERR 0x308
768 do_facet ost1 lctl set_param fail_loc=0x80000308
769 dd if=/etc/hosts of=$DIR/$tdir/$tfile && \
770 error "didn't fail open enqueue" || true
772 run_test 20b "ldlm_handle_enqueue error (should return error)"
775 mkdir -p $DIR/$tdir-1
776 mkdir -p $DIR/$tdir-2
777 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
780 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000129"
781 $MULTIOP $DIR/$tdir-2/f Oc &
784 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
786 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
787 kill -USR1 $close_pid
789 wait $close_pid || return 1
790 wait $open_pid || return 2
791 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
793 $CHECKSTAT -t file $DIR/$tdir-1/f || return 3
794 $CHECKSTAT -t file $DIR/$tdir-2/f || return 4
798 run_test 21a "drop close request while close and open are both in flight"
801 mkdir -p $DIR/$tdir-1
802 mkdir -p $DIR/$tdir-2
803 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
806 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
807 mcreate $DIR/$tdir-2/f &
810 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
812 kill -USR1 $close_pid
814 wait $close_pid || return 1
815 wait $open_pid || return 3
817 $CHECKSTAT -t file $DIR/$tdir-1/f || return 4
818 $CHECKSTAT -t file $DIR/$tdir-2/f || return 5
821 run_test 21b "drop open request while close and open are both in flight"
824 mkdir -p $DIR/$tdir-1
825 mkdir -p $DIR/$tdir-2
826 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
829 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
830 mcreate $DIR/$tdir-2/f &
833 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
835 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
836 kill -USR1 $close_pid
838 wait $close_pid || return 1
839 wait $open_pid || return 2
841 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
843 $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
844 $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
847 run_test 21c "drop both request while close and open are both in flight"
850 mkdir -p $DIR/$tdir-1
851 mkdir -p $DIR/$tdir-2
852 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
855 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000129"
856 $MULTIOP $DIR/$tdir-2/f Oc &
858 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
860 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
863 wait $pid || return 1
864 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
866 $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
867 $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
871 run_test 21d "drop close reply while close and open are both in flight"
874 mkdir -p $DIR/$tdir-1
875 mkdir -p $DIR/$tdir-2
876 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
879 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
880 touch $DIR/$tdir-2/f &
882 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
886 wait $pid || return 1
889 $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
890 $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
893 run_test 21e "drop open reply while close and open are both in flight"
896 mkdir -p $DIR/$tdir-1
897 mkdir -p $DIR/$tdir-2
898 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
901 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
902 touch $DIR/$tdir-2/f &
904 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
906 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
909 wait $pid || return 1
910 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
912 $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
913 $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
916 run_test 21f "drop both reply while close and open are both in flight"
919 mkdir -p $DIR/$tdir-1
920 mkdir -p $DIR/$tdir-2
921 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
924 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000119"
925 touch $DIR/$tdir-2/f &
927 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
929 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
932 wait $pid || return 1
933 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
935 $CHECKSTAT -t file $DIR/$tdir-1/f || return 2
936 $CHECKSTAT -t file $DIR/$tdir-2/f || return 3
939 run_test 21g "drop open reply and close request while close and open are both in flight"
942 mkdir -p $DIR/$tdir-1
943 mkdir -p $DIR/$tdir-2
944 multiop_bg_pause $DIR/$tdir-1/f O_c || return 1
947 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000107"
948 touch $DIR/$tdir-2/f &
951 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
953 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000122"
956 wait $pid || return 1
957 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
959 wait $touch_pid || return 2
961 $CHECKSTAT -t file $DIR/$tdir-1/f || return 3
962 $CHECKSTAT -t file $DIR/$tdir-2/f || return 4
965 run_test 21h "drop open request and close reply while close and open are both in flight"
967 # bug 3462 - multiple MDC requests
972 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000115"
977 $MULTIOP $f1 msu || return 1
980 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
982 wait $close_pid || return 2
983 rm -rf $f2 || return 4
985 run_test 22 "drop close request and do mknod"
988 multiop_bg_pause $DIR/$tfile O_c || return 1
990 # give a chance for open
994 drop_request "kill -USR1 $pid"
997 wait $pid || return 1
1000 run_test 23 "client hang when close a file after mds crash"
1002 test_24a() { # bug 11710 details correct fsync() behavior
1003 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1006 $LFS setstripe -i 0 -c 1 $DIR/$tdir
1007 cancel_lru_locks osc
1008 multiop_bg_pause $DIR/$tdir/$tfile Owy_wyc || return 1
1011 kill -USR1 $MULTI_PID
1014 lctl set_param fail_loc=0x0
1017 error_ignore bz5494 "multiop didn't fail fsync: rc $rc" || true
1019 run_test 24a "fsync error (should return error)"
1021 wait_client_evicted () {
1024 local varsvc=${facet}_svc
1026 wait_update $(facet_active_host $facet) \
1027 "lctl get_param -n *.${!varsvc}.num_exports | cut -d' ' -f2" \
1032 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1034 dmesg -c > /dev/null
1036 lfs setstripe $DIR/$tdir -S 0 -i 0 -c 1 ||
1037 error "$LFS setstripe failed"
1038 cancel_lru_locks osc
1039 multiop_bg_pause $DIR/$tdir/$tfile-1 Ow8192_yc ||
1040 error "mulitop Ow8192_yc failed"
1043 multiop_bg_pause $DIR/$tdir/$tfile-2 Ow8192_c ||
1044 error "mulitop Ow8192_c failed"
1049 kill -USR1 $MULTI_PID1
1052 kill -USR1 $MULTI_PID2
1055 lctl set_param fail_loc=0x0
1057 [ $rc1 -eq 0 -o $rc2 -eq 0 ] &&
1058 error_ignore bz5494 "multiop didn't fail fsync: $rc1 or close: $rc2" ||
1061 dmesg | grep "dirty page discard:" ||
1062 error "no discarded dirty page found!"
1064 run_test 24b "test dirty page discard due to client eviction"
1066 test_26a() { # was test_26 bug 5921 - evict dead exports by pinger
1067 # this test can only run from a client on a separate node.
1068 remote_ost || { skip "local OST" && return 0; }
1069 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1070 remote_mds || { skip "local MDS" && return 0; }
1072 if [ $(facet_host mgs) = $(facet_host ost1) ]; then
1073 skip "msg and ost1 are at the same node"
1077 check_timeout || return 1
1079 # OBD_FAIL_PTLRPC_DROP_RPC 0x505
1080 do_facet client lctl set_param fail_loc=0x505
1081 local before=$(date +%s)
1084 # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
1085 # But if there's a race to start the evictor from various obds,
1086 # the loser might have to wait for the next ping.
1087 sleep $((TIMEOUT * 2 + TIMEOUT * 3 / 4))
1088 do_facet client lctl set_param fail_loc=0x0
1089 do_facet client df > /dev/null
1091 local oscs=$(lctl dl | awk '/-osc-/ {print $4}')
1092 check_clients_evicted $before ${oscs[@]}
1093 check_clients_full 10 ${oscs[@]}
1095 run_test 26a "evict dead exports"
1097 test_26b() { # bug 10140 - evict dead exports by pinger
1098 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1100 if [ $(facet_host mgs) = $(facet_host ost1) ]; then
1101 skip "msg and ost1 are at the same node"
1105 check_timeout || return 1
1107 zconf_mount `hostname` $MOUNT2 ||
1108 { error "Failed to mount $MOUNT2"; return 2; }
1109 sleep 1 # wait connections being established
1111 local MDS_NEXP=$(do_facet $SINGLEMDS lctl get_param -n mdt.${mds1_svc}.num_exports | cut -d' ' -f2)
1112 local OST_NEXP=$(do_facet ost1 lctl get_param -n obdfilter.${ost1_svc}.num_exports | cut -d' ' -f2)
1114 echo starting with $OST_NEXP OST and $MDS_NEXP MDS exports
1116 zconf_umount `hostname` $MOUNT2 -f
1118 # PING_INTERVAL max(obd_timeout / 4, 1U)
1119 # PING_EVICT_TIMEOUT (PING_INTERVAL * 6)
1121 # evictor takes PING_EVICT_TIMEOUT + 3 * PING_INTERVAL to evict.
1122 # But if there's a race to start the evictor from various obds,
1123 # the loser might have to wait for the next ping.
1124 # = 9 * PING_INTERVAL + PING_INTERVAL
1125 # = 10 PING_INTERVAL = 10 obd_timeout / 4 = 2.5 obd_timeout
1126 # let's wait $((TIMEOUT * 3)) # bug 19887
1128 wait_client_evicted ost1 $OST_NEXP $((TIMEOUT * 3)) || \
1129 error "Client was not evicted by ost" rc=1
1130 wait_client_evicted $SINGLEMDS $MDS_NEXP $((TIMEOUT * 3)) || \
1131 error "Client was not evicted by mds"
1133 run_test 26b "evict dead exports"
1137 writemany -q -a $DIR/$tdir/$tfile 0 5 &
1140 local save_FAILURE_MODE=$FAILURE_MODE
1142 facet_failover $SINGLEMDS
1143 #define OBD_FAIL_OSC_SHUTDOWN 0x407
1144 do_facet $SINGLEMDS lctl set_param fail_loc=0x80000407
1145 # need to wait for reconnect
1146 echo waiting for fail_loc
1147 wait_update_facet $SINGLEMDS "lctl get_param -n fail_loc" "-2147482617"
1148 facet_failover $SINGLEMDS
1149 #no crashes allowed!
1150 kill -USR1 $CLIENT_PID
1153 FAILURE_MODE=$save_FAILURE_MODE
1155 run_test 27 "fail LOV while using OSC's"
1157 test_28() { # bug 6086 - error adding new clients
1158 do_facet client mcreate $DIR/$tfile || return 1
1159 drop_bl_callback_once "chmod 0777 $DIR/$tfile" ||
1160 echo "evicted as expected"
1161 #define OBD_FAIL_MDS_CLIENT_ADD 0x12f
1162 do_facet $SINGLEMDS "lctl set_param fail_loc=0x8000012f"
1163 # fail once (evicted), reconnect fail (fail_loc), ok
1164 client_up || (sleep 10; client_up) || (sleep 10; client_up) || error "reconnect failed"
1166 fail $SINGLEMDS # verify MDS last_rcvd can be loaded
1168 run_test 28 "handle error adding new clients (bug 6086)"
1170 test_29a() { # bug 22273 - error adding new clients
1171 #define OBD_FAIL_TGT_CLIENT_ADD 0x711
1172 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000711"
1173 # fail abort so client will be new again
1174 fail_abort $SINGLEMDS
1175 client_up || error "reconnect failed"
1176 wait_osc_import_state $SINGLEMDS ost FULL
1179 run_test 29a "error adding new clients doesn't cause LBUG (bug 22273)"
1181 test_29b() { # bug 22273 - error adding new clients
1182 #define OBD_FAIL_TGT_CLIENT_ADD 0x711
1183 do_facet ost1 "lctl set_param fail_loc=0x80000711"
1184 # fail abort so client will be new again
1186 client_up || error "reconnect failed"
1189 run_test 29b "error adding new clients doesn't cause LBUG (bug 22273)"
1193 # put a load of file creates/writes/deletes
1194 writemany -q $DIR/$tdir/$tfile 0 5 &
1196 echo writemany pid $CLIENT_PID
1200 # wait for client to reconnect to MDS
1205 # client process should see no problems even though MDS went down
1207 kill -USR1 $CLIENT_PID
1210 echo writemany returned $rc
1211 #these may fail because of eviction due to slow AST response.
1213 error_ignore bz13652 "writemany returned rc $rc" || true
1215 run_test 50 "failover MDS under load"
1218 #define OBD_FAIL_MDS_SYNC_CAPA_SL 0x1310
1219 do_facet ost1 lctl set_param fail_loc=0x00001310
1222 # put a load of file creates/writes/deletes
1223 writemany -q $DIR/$tdir/$tfile 0 5 &
1227 facet_failover $SINGLEMDS
1228 # failover at various points during recovery
1229 SEQ="1 5 10 $(seq $TIMEOUT 5 $(($TIMEOUT+10)))"
1230 echo will failover at $SEQ
1233 #echo failover in $i sec
1234 log "test_$testnum: failover in $i sec"
1236 facet_failover $SINGLEMDS
1238 # client process should see no problems even though MDS went down
1239 # and recovery was interrupted
1241 kill -USR1 $CLIENT_PID
1244 echo writemany returned $rc
1246 error_ignore bz13652 "writemany returned rc $rc" || true
1248 run_test 51 "failover MDS during recovery"
1251 do_facet client "mkdir -p $DIR/$tdir"
1252 do_facet client "writemany -q -a $DIR/$tdir/$tfile 300 5" &
1254 echo writemany pid $CLIENT_PID
1259 wait $CLIENT_PID || rc=$?
1260 # active client process should see an EIO for down OST
1261 [ $rc -eq 5 ] && { echo "writemany correctly failed $rc" && return 0; }
1262 # but timing or failover setup may allow success
1263 [ $rc -eq 0 ] && { echo "writemany succeeded" && return 0; }
1264 echo "writemany returned $rc"
1269 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1274 [ $rc -ne 0 ] && { return $rc; }
1275 # wait for client to reconnect to OST
1279 [ $rc -ne 0 ] && { return $rc; }
1286 run_test 52 "failover OST under load"
1288 # test of open reconstruct
1291 drop_ldlm_reply "openfile -f O_RDWR:O_CREAT -m 0755 $DIR/$tfile" ||\
1294 run_test 53 "touch: drop rep"
1297 zconf_mount `hostname` $MOUNT2
1299 touch $DIR2/$tfile.1
1301 cat $DIR2/$tfile.missing # save transno = 0, rc != 0 into last_rcvd
1304 ERROR=`dmesg | egrep "(test 54|went back in time)" | tail -n1 | grep "went back in time"`
1305 [ x"$ERROR" == x ] || error "back in time occured"
1307 run_test 54 "back in time"
1309 # bug 11330 - liblustre application death during I/O locks up OST
1311 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
1315 # This test assumes relatively small max_dirty_mb setting
1316 # which we want to walk away from, so just for it we will
1317 # temporarily lower the value
1318 local max_dirty_mb=$(lctl get_param -n osc.*.max_dirty_mb | head -n 1)
1319 lctl set_param -n osc.*.max_dirty_mb=32
1320 stack_trap "lctl set_param osc.*.max_dirty_mb=$max_dirty_mb" EXIT
1322 # Minimum pass speed is 2MBps
1324 # LU-2887/LU-3089 - set min pass speed to 500KBps
1325 [ "$(facet_fstype ost1)" = "zfs" ] && ddtimeout=256
1327 # first dd should be finished quickly
1328 $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-1
1329 dd if=/dev/zero of=$DIR/$tdir/$tfile-1 bs=32M count=4 &
1332 echo "step1: testing ......"
1333 while kill -0 $DDPID 2> /dev/null; do
1335 if [ $count -gt $ddtimeout ]; then
1336 error "dd should be finished!"
1340 echo "(dd_pid=$DDPID, time=$count)successful"
1342 $LFS setstripe -c 1 -i 0 $DIR/$tdir/$tfile-2
1343 #define OBD_FAIL_OST_DROP_REQ 0x21d
1344 do_facet ost1 lctl set_param fail_loc=0x0000021d
1345 # second dd will be never finished
1346 dd if=/dev/zero of=$DIR/$tdir/$tfile-2 bs=32M count=4 &
1349 echo "step2: testing ......"
1350 while [ $count -le $ddtimeout ]; do
1351 if ! kill -0 $DDPID 2> /dev/null; then
1353 error "dd shouldn't be finished! (time=$count)"
1358 echo "(dd_pid=$DDPID, time=$count)successful"
1360 #Recover fail_loc and dd will finish soon
1361 do_facet ost1 lctl set_param fail_loc=0
1363 echo "step3: testing ......"
1364 while kill -0 $DDPID 2> /dev/null; do
1366 if [ $count -gt $((ddtimeout + 440)) ]; then
1367 error "dd should be finished!"
1371 echo "(dd_pid=$DDPID, time=$count)successful"
1375 run_test 55 "ost_brw_read/write drops timed-out read/write request"
1377 test_56() { # b=11277
1378 #define OBD_FAIL_MDS_RESEND 0x136
1380 do_facet $SINGLEMDS "lctl set_param fail_loc=0x80000136"
1381 stat $DIR/$tfile || error "stat failed"
1382 do_facet $SINGLEMDS "lctl set_param fail_loc=0"
1385 run_test 56 "do not fail on getattr resend"
1388 # no oscs means no client or mdt
1389 while lctl get_param osc.*.* > /dev/null 2>&1; do
1390 : # loop until proc file is removed
1394 test_57() { # bug 10866
1398 #define OBD_FAIL_LPROC_REMOVE 0xB00
1399 lctl set_param fail_loc=0x80000B00
1400 zconf_umount `hostname` $DIR
1401 lctl set_param fail_loc=0x80000B00
1402 fail_abort $SINGLEMDS
1404 lctl set_param fail_loc=0
1406 do_facet client "df $DIR"
1408 run_test 57 "read procfs entries causes kernel crash"
1410 test_58() { # bug 11546
1411 #define OBD_FAIL_MDC_ENQUEUE_PAUSE 0x801
1414 lctl set_param fail_loc=0x80000801
1415 cp $DIR/$tfile /dev/null &
1418 lctl set_param fail_loc=0
1419 drop_bl_callback_once rm -f $DIR/$tfile
1421 # the first 'df' could tigger the eviction caused by
1422 # 'drop_bl_callback_once', and it's normal case.
1423 # but the next 'df' should return successfully.
1424 do_facet client "df $DIR" || do_facet client "df $DIR"
1426 run_test 58 "Eviction in the middle of open RPC reply processing"
1428 test_59() { # bug 10589
1429 zconf_mount `hostname` $MOUNT2 || error "Failed to mount $MOUNT2"
1430 echo $DIR2 | grep -q $MOUNT2 || error "DIR2 is not set properly: $DIR2"
1431 #define OBD_FAIL_LDLM_CANCEL_EVICT_RACE 0x311
1432 lctl set_param fail_loc=0x311
1433 writes=$(LANG=C dd if=/dev/zero of=$DIR2/$tfile count=1 2>&1)
1434 [ $? = 0 ] || error "dd write failed"
1435 writes=$(echo $writes | awk -F '+' '/out/ {print $1}')
1436 lctl set_param fail_loc=0
1438 zconf_umount `hostname` $MOUNT2 -f
1439 reads=$(LANG=C dd if=$DIR/$tfile of=/dev/null 2>&1)
1440 [ $? = 0 ] || error "dd read failed"
1441 reads=$(echo $reads | awk -F '+' '/in/ {print $1}')
1442 [ "$reads" -eq "$writes" ] || error "read" $reads "blocks, must be" $writes
1444 run_test 59 "Read cancel race on client eviction"
1447 local num_files=${COUNT:-5000}
1448 test_mkdir $DIR/$tdir
1450 # Register (and start) changelog
1451 changelog_register || error "changelog_register failed"
1453 # Generate a large number of changelog entries
1454 createmany -o $DIR/$tdir/$tfile $num_files
1458 # Unlink files in the background
1459 unlinkmany $DIR/$tdir/$tfile $num_files &
1463 # Failover the MDS while unlinks are happening
1464 facet_failover $SINGLEMDS
1466 # Wait for unlinkmany to finish
1469 # Check if all the create/unlink events were recorded
1471 local cl_count=$(changelog_dump | grep -c UNLNK)
1472 echo "$cl_count unlinks in changelog"
1474 changelog_deregister || error "changelog_deregister failed"
1475 if ! changelog_users $SINGLEMDS | grep -q "^cl"; then
1476 [ $cl_count -eq $num_files ] ||
1477 error "Recorded $cl_count of $num_files unlinks"
1478 # Also make sure we can clear large changelogs
1479 cl_count=$(changelog_dump | wc -l)
1480 [ $cl_count -le 2 ] ||
1481 error "Changelog not empty: $cl_count entries"
1482 else # If other users, there may be other unlinks in the log
1483 [ $cl_count -ge $num_files ] ||
1484 error "Recorded $cl_count of $num_files unlinks"
1485 changelog_users $SINGLEMDS
1486 echo "other changelog users; can't verify clear"
1489 run_test 60 "Add Changelog entries during MDS failover"
1493 local mdtosc=$(get_mdtosc_proc_path $SINGLEMDS $FSNAME-OST0000)
1494 mdtosc=${mdtosc/-MDT*/-MDT\*}
1495 local cflags="osc.$mdtosc.connect_flags"
1496 do_facet $SINGLEMDS "lctl get_param -n $cflags" |grep -q skip_orphan
1497 [ $? -ne 0 ] && skip "don't have skip orphan feature" && return
1499 mkdir -p $DIR/$tdir || error "mkdir dir $DIR/$tdir failed"
1500 # Set the default stripe of $DIR/$tdir to put the files to ost1
1501 $LFS setstripe -c 1 -i 0 $DIR/$tdir
1503 replay_barrier $SINGLEMDS
1504 createmany -o $DIR/$tdir/$tfile-%d 10
1505 local oid=$(do_facet ost1 "lctl get_param -n \
1506 obdfilter.${ost1_svc}.last_id" | sed -e 's/.*://')
1508 fail_abort $SINGLEMDS
1510 touch $DIR/$tdir/$tfile
1511 local id=$($LFS getstripe $DIR/$tdir/$tfile |
1512 awk '$1 == 0 { print $2 }')
1513 [ $id -le $oid ] && error "the orphan objid was reused, failed"
1518 run_test 61 "Verify to not reuse orphan objects - bug 17025"
1520 # test_62 as seen it b2_1 please do not reuse test_62
1523 # zconf_umount `hostname` $DIR
1524 # #define OBD_FAIL_PTLRPC_DELAY_IMP_FULL 0x516
1525 # lctl set_param fail_loc=0x516
1528 #run_test 62 "Verify connection flags race - bug LU-1716"
1532 [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.7.51) ]] ||
1533 { skip "Need MDS version at least 2.7.51"; return 0; }
1535 local list=$(comma_list $(osts_nodes))
1537 # modify dir so that next revalidate would not obtain UPDATE lock
1540 # drop 1 reply with UPDATE lock
1541 mcreate $DIR/$tfile || error "mcreate failed: $?"
1542 drop_ldlm_reply_once "stat $DIR/$tfile" &
1545 # make the re-sent lock to sleep
1546 #define OBD_FAIL_MDS_RESEND 0x136
1547 do_nodes $list $LCTL set_param fail_loc=0x80000136
1549 #initiate the re-connect & re-send
1550 local mdccli=$($LCTL dl | awk '/-mdc-/ {print $4;}')
1551 local conn_uuid=$($LCTL get_param -n mdc.${mdccli}.mds_conn_uuid)
1552 $LCTL set_param "mdc.${mdccli}.import=connection=${conn_uuid}"
1555 #initiate the client eviction while enqueue re-send is in progress
1561 run_test 66 "lock enqueue re-send vs client eviction"
1566 #grant lock1, export2
1567 $SETSTRIPE -i -0 $DIR2/$tfile || return 1
1568 $MULTIOP $DIR2/$tfile Ow || return 2
1570 #define OBD_FAIL_LDLM_BL_EVICT 0x31e
1571 do_facet ost $LCTL set_param fail_loc=0x31e
1572 #get waiting lock2, export1
1573 $MULTIOP $DIR/$tfile Ow &
1575 # let enqueue to get asleep
1579 $MULTIOP $DIR2/$tfile Ow &
1587 do_facet ost $LCTL set_param fail_loc=0
1594 run_test 65 "lock enqueue for destroyed export"
1596 check_cli_ir_state()
1598 local NODE=${1:-$HOSTNAME}
1600 st=$(do_node $NODE "lctl get_param mgc.*.ir_state |
1601 awk '/imperative_recovery:/ { print \\\$2}'")
1602 [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
1603 error "Error state $st, must be ENABLED or DISABLED"
1607 check_target_ir_state()
1610 local name=${target}_svc
1611 local recovery_proc=obdfilter.${!name}.recovery_status
1615 st=$(do_facet $target "$LCTL get_param -n $recovery_proc |
1616 awk '/status:/{ print \\\$2}'")
1617 [ x$st = xRECOVERING ] || break
1619 st=$(do_facet $target "lctl get_param -n $recovery_proc |
1620 awk '/IR:/{ print \\\$2}'")
1621 [ $st != ON -o $st != OFF -o $st != ENABLED -o $st != DISABLED ] ||
1622 error "Error state $st, must be ENABLED or DISABLED"
1628 do_facet mgs lctl set_param -n mgs.MGS.live.$FSNAME="state=$1"
1633 local state=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
1634 awk '/state:/{ print \\\$2 }'")
1638 nidtbl_version_mgs()
1640 local ver=$(do_facet mgs "lctl get_param -n mgs.MGS.live.$FSNAME |
1641 awk '/nidtbl_version:/{ print \\\$2 }'")
1645 # nidtbl_version_client <mds1|client> [node]
1646 nidtbl_version_client()
1649 local node=${2:-$HOSTNAME}
1651 if [ X$cli = Xclient ]; then
1654 local obdtype=${cli/%[0-9]*/}
1655 [ $obdtype != mds ] && error "wrong parameters $cli"
1657 node=$(facet_active_host $cli)
1662 local vers=$(do_node $node "lctl get_param -n mgc.*.ir_state" |
1663 awk "/$cli/{print \$6}" |sort -u)
1665 # in case there are multiple mounts on the client node
1667 [ ${#arr[@]} -ne 1 ] && error "versions on client node mismatch"
1671 nidtbl_versions_match()
1673 [ $(nidtbl_version_mgs) -eq $(nidtbl_version_client ${1:-client}) ]
1676 target_instance_match()
1682 obdtype=${srv/%[0-9]*/}
1693 error "invalid target type" $srv
1698 local target=${srv}_svc
1699 local si=$(do_facet $srv lctl get_param -n $obdname.${!target}.instance)
1700 local ci=$(lctl get_param -n $cliname.${!target}-${cliname}-*.import |
1701 awk '/instance/{ print $2 }' | head -n1)
1703 return $([ $si -eq $ci ])
1708 do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1709 { skip "MGS without IR support"; return 0; }
1711 # MDT was just restarted in the previous test, make sure everything
1714 while [ $cnt -gt 0 ]; do
1715 nidtbl_versions_match && break
1721 set_ir_status disabled
1723 local prev_ver=$(nidtbl_version_client client)
1725 local saved_FAILURE_MODE=$FAILURE_MODE
1726 [ $(facet_host mgs) = $(facet_host ost1) ] && FAILURE_MODE="SOFT"
1730 [ $(nidtbl_version_client client) -eq $prev_ver ] ||
1731 error "version must not change due to IR disabled"
1732 target_instance_match ost1 || error "instance mismatch"
1736 FAILURE_MODE=$saved_FAILURE_MODE
1738 run_test 100 "IR: Make sure normal recovery still works w/o IR"
1742 do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1743 { skip "MGS without IR support"; return 0; }
1747 local OST1_IMP=$(get_osc_import_name client ost1)
1749 # disable pinger recovery
1750 lctl set_param -n osc.$OST1_IMP.pinger_recov=0
1754 target_instance_match ost1 || error "instance mismatch"
1755 nidtbl_versions_match || error "version must match"
1757 lctl set_param -n osc.$OST1_IMP.pinger_recov=1
1759 run_test 101 "IR: Make sure IR works w/o normal recovery"
1763 do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1764 { skip "MGS without IR support"; return 0; }
1766 local clients=${CLIENTS:-$HOSTNAME}
1773 # let's have a new nidtbl version
1776 # sleep for a while so that clients can see the failure of ost
1777 # it must be MGC_TIMEOUT_MIN_SECONDS + MGC_TIMEOUT_RAND_CENTISEC.
1778 # int mgc_request.c:
1779 # define MGC_TIMEOUT_MIN_SECONDS 5
1780 # define MGC_TIMEOUT_RAND_CENTISEC 0x1ff /* ~500 *
1781 local count=30 # 20 seconds at most
1782 while [ $count -gt 0 ]; do
1783 nidtbl_versions_match && break
1788 nidtbl_versions_match || error "nidtbl mismatch"
1791 old_version=$(nidtbl_version_client client)
1793 zconf_umount_clients $clients $MOUNT || error "Cannot umount client"
1796 combined_mgs_mds && mgsdev=mds1
1797 remount_facet $mgsdev
1800 zconf_mount_clients $clients $MOUNT || error "Cannot mount client"
1803 new_version=$(nidtbl_version_client client)
1804 [ $new_version -lt $old_version ] &&
1805 error "nidtbl version wrong after mgs restarts"
1808 run_test 102 "IR: New client gets updated nidtbl after MGS restart"
1812 do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1813 { skip "MGS without IR support"; return 0; }
1815 combined_mgs_mds && skip "needs separate mgs and mds" && return 0
1817 # workaround solution to generate config log on the mds
1823 # We need this test because mds is like a client in IR context.
1824 start mds1 $(mdsdevname 1) $MDS_MOUNT_OPTS ||
1825 error "MDS should start w/o mgs"
1827 # start mgs and remount mds w/ ir
1828 start mgs $(mgsdevname) $MGS_MOUNT_OPTS
1831 # remount client so that fsdb will be created on the MGS
1832 umount_client $MOUNT || error "umount failed"
1833 mount_client $MOUNT || error "mount failed"
1835 # sleep 30 seconds so the MDS has a chance to detect MGS restarting
1837 while [ $count -gt 0 ]; do
1838 [ $(nidtbl_version_client mds1) -ne 0 ] && break
1843 # after a while, mds should be able to reconnect to mgs and fetch
1844 # up-to-date nidtbl version
1845 nidtbl_versions_match mds1 || error "mds nidtbl mismatch"
1850 run_test 103 "IR: MDS can start w/o MGS and get updated nidtbl later"
1854 do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1855 { skip "MGS without IR support"; return 0; }
1860 start ost1 $(ostdevname 1) "$OST_MOUNT_OPTS -onoir" ||
1861 error "OST1 cannot start"
1864 local ir_state=$(check_target_ir_state ost1)
1865 [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1866 error "ir status on ost1 should be DISABLED"
1868 run_test 104 "IR: ost can disable IR voluntarily"
1872 [ -z "$RCLIENTS" ] && skip "Needs multiple clients" && return 0
1873 do_facet mgs $LCTL list_param mgs.*.ir_timeout ||
1874 { skip "MGS without IR support"; return 0; }
1878 # get one of the clients from client list
1879 local rcli=$(echo $RCLIENTS |cut -d' ' -f 1)
1881 local mount_opts=${MOUNT_OPTS:+$MOUNT_OPTS,}noir
1882 zconf_umount $rcli $MOUNT || error "umount failed"
1883 zconf_mount $rcli $MOUNT $mount_opts || error "mount failed"
1885 # make sure lustre mount at $rcli disabling IR
1886 local ir_state=$(check_cli_ir_state $rcli)
1887 [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1888 error "IR state must be DISABLED at $rcli"
1890 # Since the client just mounted, its last_rcvd entry is not on disk.
1891 # Send an RPC so exp_need_sync forces last_rcvd to commit this export
1892 # so the client can reconnect during OST recovery (LU-924, LU-1582)
1893 $SETSTRIPE -i 0 $DIR/$tfile
1894 dd if=/dev/zero of=$DIR/$tfile bs=1M count=1 conv=sync
1896 # make sure MGS's state is Partial
1897 [ $(get_ir_status) = "partial" ] || error "MGS IR state must be partial"
1900 # make sure IR on ost1 is DISABLED
1901 local ir_state=$(check_target_ir_state ost1)
1902 [ $ir_state = "DISABLED" -o $ir_state = "OFF" ] ||
1903 error "IR status on ost1 should be DISABLED"
1905 # remount with the default MOUNT_OPTS
1906 zconf_umount $rcli $MOUNT || error "umount failed"
1907 zconf_mount $rcli $MOUNT || error "mount failed"
1909 # make sure MGS's state is full
1910 [ $(get_ir_status) = "full" ] || error "MGS IR status must be full"
1913 # make sure IR on ost1 is ENABLED
1914 local ir_state=$(check_target_ir_state ost1)
1915 [ $ir_state = "ENABLED" -o $ir_state = "ON" ] ||
1916 error "IR status on ost1 should be ENABLED"
1920 run_test 105 "IR: NON IR clients support"
1928 test_106() { # LU-1789
1929 [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.50) ]] ||
1930 { skip "Need MDS version at least 2.3.50"; return 0; }
1932 #define OBD_FAIL_MDC_LIGHTWEIGHT 0x805
1933 $LCTL set_param fail_loc=0x805
1936 trap cleanup_106 EXIT
1938 # enable lightweight flag on mdc connection
1941 local MDS_NEXP=$(do_facet $SINGLEMDS \
1942 lctl get_param -n mdt.${mds1_svc}.num_exports |
1944 $LCTL set_param fail_loc=0
1946 touch $DIR2/$tfile || error "failed to create empty file"
1947 replay_barrier $SINGLEMDS
1949 $LCTL set_param debug=console
1951 facet_failover $SINGLEMDS
1953 # lightweight connection must be evicted
1954 touch -c $DIR2/$tfile || true
1955 $LCTL dk $TMP/lustre-log-$TESTNAME.log
1956 evicted=`awk '/This client was evicted by .*MDT0000/ {
1958 }' $TMP/lustre-log-$TESTNAME.log`
1959 [ -z "$evicted" ] && error "lightweight client not evicted by mds"
1961 # and all operations performed by lightweight client should be
1962 # synchronous, so the file created before mds restart should be there
1963 $CHECKSTAT -t file $DIR/$tfile || error "file not present"
1968 run_test 106 "lightweight connection support"
1975 # OBD_FAIL_MDS_REINT_NET_REP 0x119
1976 do_facet $SINGLEMDS lctl set_param fail_loc=0x119
1977 multiop $DIR/$tdir D_c &
1979 mkdir $DIR/$tdir/dir_106 &
1981 do_facet $SINGLEMDS lctl set_param fail_loc=0
1984 wait $CLIENT_PID || rc=$?
1985 checkstat -t dir $DIR/$tdir/dir_106 || return 1
1987 kill -USR1 $close_pid
1988 wait $close_pid || return 2
1992 run_test 107 "drop reint reply, then restart MDT"
1996 $SETSTRIPE -c 1 -i 0 $DIR/$tdir
1998 dd if=/dev/zero of=$DIR/$tdir/$tfile bs=1M count=256 &
2006 client_up || error "reconnect failed"
2007 rm -f $DIR/$tdir/$tfile
2009 run_test 108 "client eviction don't crash"
2012 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2013 local remote_dir=$DIR/$tdir/remote_dir
2017 #prepare for 110 test, which need set striped dir on remote MDT.
2018 for num in $(seq $MDSCOUNT); do
2020 lctl set_param -n mdt.$FSNAME*.enable_remote_dir=1 \
2025 drop_request "$LFS mkdir -i $mdtidx -c2 $remote_dir" ||
2026 error "lfs mkdir failed"
2027 local diridx=$($LFS getstripe -m $remote_dir)
2028 [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
2030 rm -rf $DIR/$tdir || error "rmdir failed"
2032 run_test 110a "create remote directory: drop client req"
2035 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2036 local remote_dir=$DIR/$tdir/remote_dir
2040 drop_reint_reply "$LFS mkdir -i $mdtidx -c2 $remote_dir" ||
2041 error "lfs mkdir failed"
2043 diridx=$($LFS getstripe -m $remote_dir)
2044 [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
2046 rm -rf $DIR/$tdir || error "rmdir failed"
2048 run_test 110b "create remote directory: drop Master rep"
2051 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2052 local remote_dir=$DIR/$tdir/remote_dir
2056 drop_update_reply $mdtidx "$LFS mkdir -i $mdtidx -c2 $remote_dir" ||
2057 error "lfs mkdir failed"
2059 diridx=$($GETSTRIPE -m $remote_dir)
2060 [ $diridx -eq $mdtidx ] || error "$diridx != $mdtidx"
2062 rm -rf $DIR/$tdir || error "rmdir failed"
2064 run_test 110c "create remote directory: drop update rep on slave MDT"
2067 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2068 local remote_dir=$DIR/$tdir/remote_dir
2072 $LFS mkdir -i $MDTIDX -c2 $remote_dir || error "lfs mkdir failed"
2074 drop_request "rm -rf $remote_dir" || error "rm remote dir failed"
2076 rm -rf $DIR/$tdir || error "rmdir failed"
2080 run_test 110d "remove remote directory: drop client req"
2083 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2084 local remote_dir=$DIR/$tdir/remote_dir
2088 $LFS mkdir -i $MDTIDX -c2 $remote_dir || error "lfs mkdir failed"
2089 drop_reint_reply "rm -rf $remote_dir" || error "rm remote dir failed"
2091 rm -rf $DIR/$tdir || error "rmdir failed"
2095 run_test 110e "remove remote directory: drop master rep"
2098 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2099 local remote_dir=$DIR/$tdir/remote_dir
2103 $LFS mkdir -i $MDTIDX -c2 $remote_dir || error "lfs mkdir failed"
2104 drop_update_reply $MDTIDX "rm -rf $remote_dir" ||
2105 error "rm remote dir failed"
2107 rm -rf $DIR/$tdir || error "rmdir failed"
2109 run_test 110f "remove remote directory: drop slave rep"
2112 [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.11.0) ]] ||
2113 { skip "Need MDS version at least 2.11.0"; return 0; }
2115 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2118 touch $DIR/$tdir/$tfile
2120 # OBD_FAIL_MDS_REINT_NET_REP 0x119
2121 do_facet mds1 $LCTL set_param fail_loc=0x119
2122 $LFS migrate -m 1 $DIR/$tdir &
2125 do_facet mds1 $LCTL set_param fail_loc=0
2129 mdt_index=$($LFS getstripe -m $DIR/$tdir)
2130 [ $mdt_index == 1 ] || error "$tdir is not on MDT1"
2131 mdt_index=$($LFS getstripe -m $DIR/$tdir/$tfile)
2132 [ $mdt_index == 1 ] || error "$tfile is not on MDT1"
2134 rm -rf $DIR/$tdir || error "rmdir failed"
2136 run_test 110g "drop reply during migration"
2139 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2140 local server_version=$(lustre_version_code mds1)
2141 [[ $server_version -ge $(version_code 2.7.56) ]] ||
2142 { skip "Need MDS version at least 2.7.56"; return 0; }
2144 local src_dir=$DIR/$tdir/source_dir
2145 local tgt_dir=$DIR/$tdir/target_dir
2149 $LFS mkdir -i $MDTIDX $tgt_dir
2151 dd if=/etc/hosts of=$src_dir/src_file
2152 touch $tgt_dir/tgt_file
2153 drop_update_reply $MDTIDX \
2154 "mrename $src_dir/src_file $tgt_dir/tgt_file" ||
2155 error "mrename failed"
2157 $CHECKSTAT -t file $src_dir/src_file &&
2158 error "src_file present after rename"
2160 diff /etc/hosts $tgt_dir/tgt_file ||
2161 error "file changed after rename"
2164 run_test 110h "drop update reply during cross-MDT file rename"
2167 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2168 local server_version=$(lustre_version_code mds1)
2169 [[ $server_version -ge $(version_code 2.7.56) ]] ||
2170 { skip "Need MDS version at least 2.7.56"; return 0; }
2172 local src_dir=$DIR/$tdir/source_dir
2173 local tgt_dir=$DIR/$tdir/target_dir
2177 $LFS mkdir -i $MDTIDX $tgt_dir
2179 mkdir $src_dir/src_dir
2180 touch $src_dir/src_dir/a
2181 mkdir $tgt_dir/tgt_dir
2182 drop_update_reply $MDTIDX \
2183 "mrename $src_dir/src_dir $tgt_dir/tgt_dir" ||
2184 error "mrename failed"
2186 $CHECKSTAT -t dir $src_dir/src_dir &&
2187 error "src_dir present after rename"
2189 $CHECKSTAT -t dir $tgt_dir/tgt_dir ||
2190 error "tgt_dir not present after rename"
2192 $CHECKSTAT -t file $tgt_dir/tgt_dir/a ||
2193 error "a not present after rename"
2195 run_test 110i "drop update reply during cross-MDT dir rename"
2198 [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return 0
2199 local server_version=$(lustre_version_code mds1)
2200 [[ $server_version -ge $(version_code 2.7.56) ]] ||
2201 { skip "Need MDS version at least 2.7.56"; return 0; }
2203 local remote_dir=$DIR/$tdir/remote_dir
2204 local local_dir=$DIR/$tdir/local_dir
2208 mkdir $DIR/$tdir/local_dir
2209 $LFS mkdir -i $MDTIDX $remote_dir
2211 touch $local_dir/local_file
2212 drop_update_reply $MDTIDX \
2213 "ln $local_dir/local_file $remote_dir/remote_file" ||
2216 $CHECKSTAT -t file $remote_dir/remote_file ||
2217 error "remote not present after ln"
2219 run_test 110j "drop update reply during cross-MDT ln"
2221 # LU-2844 mdt prepare fail should not cause umount oops
2224 [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.3.62) ]] ||
2225 { skip "Need MDS version at least 2.3.62"; return 0; }
2227 #define OBD_FAIL_MDS_CHANGELOG_INIT 0x151
2228 do_facet $SINGLEMDS lctl set_param fail_loc=0x151
2229 stop $SINGLEMDS || error "stop MDS failed"
2230 start $SINGLEMDS $(mdsdevname ${SINGLEMDS//mds/}) &&
2231 error "start MDS should fail"
2232 do_facet $SINGLEMDS lctl set_param fail_loc=0
2233 start $SINGLEMDS $(mdsdevname ${SINGLEMDS//mds/}) ||
2234 error "start MDS failed"
2236 run_test 111 "mdd setup fail should not cause umount oops"
2240 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
2242 do_facet_random_file client $TMP/$tfile 100K ||
2243 error_noexit "Create random file $TMP/$tfile"
2245 pause_bulk "cp $TMP/$tfile $DIR/$tfile" $TIMEOUT ||
2246 error_noexit "Can't pause_bulk copy"
2249 # expect cmp to succeed, client resent bulk
2250 cmp $TMP/$tfile $DIR/$tfile ||
2251 error_noexit "Wrong data has been written"
2253 error_noexit "Can't remove file"
2256 run_test 112a "bulk resend while orignal request is in progress"
2263 dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1
2264 cancel_lru_locks osc
2267 $LCTL set_param fail_loc=$fail1 fail_val=3
2268 dd of=/dev/null if=$DIR/$tfile bs=4096 count=1 &
2272 set_nodes_failloc "$(osts_nodes)" $fail2
2274 wait $pid || error "dd failed"
2282 local fail_val2=${4:-0}
2288 $LCTL set_param fail_loc=$fail1 fail_val=4
2289 dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1 oflag=dsync &
2294 set_nodes_failloc "$(osts_nodes)" $fail2 $fail_val2
2298 [ $error -eq 0 ] && [ $rc -ne 0 ] && error "dd error ($rc)"
2299 [ $error -ne 0 ] && [ $rc -eq 0 ] && error "dd success"
2304 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2305 skip "need at least 2.8.50 on OST" && return 0
2307 #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK 0x51b
2308 #define OBD_FAIL_PTLRPC_DROP_BULK 0x51a
2309 test_115_read 0x8000051b 0x8000051a
2311 run_test 115a "read: late REQ MDunlink and no bulk"
2314 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2315 skip "need at least 2.8.50 on OST" && return 0
2317 #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK 0x51b
2318 #define OBD_FAIL_OST_ENOSPC 0x215
2320 # pass $OSTCOUNT for the fail_loc to be caught
2321 # appropriately by the IO thread
2322 test_115_write 0x8000051b 0x80000215 1 $OSTCOUNT
2324 run_test 115b "write: late REQ MDunlink and no bulk"
2327 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2328 skip "need at least 2.8.50 on OST" && return 0
2330 #define OBD_FAIL_PTLRPC_LONG_REPL_UNLINK 0x50f
2331 #define OBD_FAIL_PTLRPC_DROP_BULK 0x51a
2332 test_115_read 0x8000050f 0x8000051a
2334 run_test 115c "read: late Reply MDunlink and no bulk"
2337 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2338 skip "need at least 2.8.50 on OST" && return 0
2340 #define OBD_FAIL_PTLRPC_LONG_REPL_UNLINK 0x50f
2341 #define OBD_FAIL_OST_ENOSPC 0x215
2342 test_115_write 0x8000050f 0x80000215 0
2344 run_test 115d "write: late Reply MDunlink and no bulk"
2347 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2348 skip "need at least 2.8.50 on OST" && return 0
2350 #define OBD_FAIL_PTLRPC_LONG_BULK_UNLINK 0x510
2351 #define OBD_FAIL_OST_ALL_REPLY_NET 0x211
2352 test_115_read 0x80000510 0x80000211
2354 run_test 115e "read: late Bulk MDunlink and no reply"
2357 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2358 skip "need at least 2.8.50 on OST" && return 0
2360 #define OBD_FAIL_PTLRPC_LONG_REQ_UNLINK 0x51b
2361 #define OBD_FAIL_OST_ALL_REPLY_NET 0x211
2362 test_115_read 0x8000051b 0x80000211
2364 run_test 115f "read: late REQ MDunlink and no reply"
2367 [ $(lustre_version_code ost1) -lt $(version_code 2.8.50) ] &&
2368 skip "need at least 2.8.50 on OST" && return 0
2370 #define OBD_FAIL_PTLRPC_LONG_BOTH_UNLINK 0x51c
2371 test_115_read 0x8000051c 0
2373 run_test 115g "read: late REQ MDunlink and Reply MDunlink"
2375 # parameters: fail_loc CMD RC
2382 #define OBD_FAIL_LDLM_CP_CB_WAIT2 0x320
2383 #define OBD_FAIL_LDLM_CP_CB_WAIT3 0x321
2384 #define OBD_FAIL_LDLM_CP_CB_WAIT4 0x322
2385 #define OBD_FAIL_LDLM_CP_CB_WAIT5 0x323
2388 echo -n "** FLOCK REPLY vs. EVICTION race, lock $2"
2389 [ "$1" = "CLEANUP" ] &&
2390 fail=0x80000320 && echo ", $1 cp first"
2391 [ "$1" = "REPLY" ] &&
2392 fail=0x80000321 && echo ", $1 cp first"
2393 [ "$1" = "DEADLOCK CLEANUP" ] &&
2394 fail=0x80000322 && echo " DEADLOCK, CLEANUP cp first"
2395 [ "$1" = "DEADLOCK REPLY" ] &&
2396 fail=0x80000323 && echo " DEADLOCK, REPLY cp first"
2398 if [ x"$2" = x"get" ]; then
2399 #for TEST lock, take a conflict in advance
2400 # sleep longer than evictor to not confuse fail_loc: 2+2+4
2401 echo "** Taking conflict **"
2402 flocks_test 5 set read sleep 10 $DIR/$tfile &
2408 $LCTL set_param fail_loc=$fail
2410 flocks_test 5 $2 write $DIR/$tfile &
2414 echo "** Evicting and re-connecting client **"
2419 if [ x"$2" = x"get" ]; then
2426 # check if the return value is allowed
2427 [ $rc -eq $3 ] && rc=0
2429 $LCTL set_param fail_loc=0
2433 # a lock is taken, unlock vs. cleanup_resource() race for destroying
2434 # the ORIGINAL lock.
2439 flocks_test 5 set write sleep 4 $DIR/$tfile &
2443 # let unlock to sleep in CP CB
2444 $LCTL set_param fail_loc=$1
2447 # let cleanup to cleep in CP CB
2455 $LCTL set_param fail_loc=0
2460 flock_is_enabled || { skip "mount w/o flock enabled" && return; }
2463 test_120_reply "CLEANUP" set 5 || error "SET race failed"
2464 test_120_reply "CLEANUP" get 5 || error "GET race failed"
2465 test_120_reply "CLEANUP" unlock 5 || error "UNLOCK race failed"
2467 test_120_reply "REPLY" set 5 || error "SET race failed"
2468 test_120_reply "REPLY" get 5 || error "GET race failed"
2469 test_120_reply "REPLY" unlock 5 || error "UNLOCK race failed"
2472 test_120_reply "DEADLOCK CLEANUP" set 5 || error "DEADLOCK race failed"
2473 test_120_reply "DEADLOCK REPLY" set 35 || error "DEADLOCK race failed"
2475 test_120_destroy 0x320 || error "unlock-cleanup race failed"
2477 run_test 120 "flock race: completion vs. evict"
2480 local BEFORE=$(date +%s)
2483 # modify dir so that next revalidate would not obtain UPDATE lock
2486 # drop 1 reply with UPDATE lock,
2487 # resend should not create 2nd lock on server
2488 mcreate $DIR/$tfile || error "mcreate failed: $?"
2489 drop_ldlm_reply_once "stat $DIR/$tfile" || error "stat failed: $?"
2491 # 2 BL AST will be sent to client, both must find the same lock,
2492 # race them to not get EINVAL for 2nd BL AST
2493 #define OBD_FAIL_LDLM_PAUSE_CANCEL2 0x31f
2494 $LCTL set_param fail_loc=0x8000031f
2496 $LCTL set_param ldlm.namespaces.*.early_lock_cancel=0 > /dev/null
2497 chmod 0777 $DIR/$tfile || error "chmod failed: $?"
2498 $LCTL set_param ldlm.namespaces.*.early_lock_cancel=1 > /dev/null
2500 # let the client reconnect
2502 EVICT=$($LCTL get_param mdc.$FSNAME-MDT*.state |
2503 awk -F"[ [,]" '/EVICTED ]$/ { if (mx<$5) {mx=$5;} } END { print mx }')
2505 [ -z "$EVICT" ] || [[ $EVICT -le $BEFORE ]] || error "eviction happened"
2507 run_test 113 "ldlm enqueue dropped reply should not cause deadlocks"
2511 test_mkdir -p $DIR/$tdir
2513 # Prevent interference from layout intent RPCs due to
2514 # asynchronous writeback. These will be tested in 130c below.
2515 do_nodes ${CLIENTS:-$HOSTNAME} sync
2517 # get only LOOKUP lock on $tdir
2518 cancel_lru_locks mdc
2519 ls $DIR/$tdir/$tfile 2>/dev/null
2521 # get getattr by fid on $tdir
2523 # we need to race with unlink, unlink must complete before we will
2524 # take a DLM lock, otherwise unlink will wait until getattr will
2525 # complete; but later than getattr starts so that getattr found
2527 #define OBD_FAIL_MDS_INTENT_DELAY 0x160
2528 set_nodes_failloc "$(mdts_nodes)" 0x80000160
2535 # drop the reply so that resend happens on an unlinked file.
2536 #define OBD_FAIL_MDS_LDLM_REPLY_NET 0x157
2537 set_nodes_failloc "$(mdts_nodes)" 0x80000157
2541 remote_mds_nodsh && skip "remote MDS with nodsh" && return
2542 local server_version=$(lustre_version_code $SINGLEMDS)
2543 [[ $server_version -ge $(version_code 2.7.2) ]] ||
2544 { skip "Need server version newer than 2.7.1"; return 0; }
2548 wait $T130_PID || [ $? -eq 0 ] && error "stat should fail"
2551 run_test 130a "enqueue resend on not existing file"
2554 remote_mds_nodsh && skip "remote MDS with nodsh" && return
2555 local server_version=$(lustre_version_code $SINGLEMDS)
2556 [[ $server_version -ge $(version_code 2.7.2) ]] ||
2557 { skip "Need server version newer than 2.7.1"; return 0; }
2560 # let the reply to be dropped
2563 #define OBD_FAIL_SRV_ENOENT 0x217
2564 set_nodes_failloc "$(mdts_nodes)" 0x80000217
2566 wait $T130_PID || [ $? -eq 0 ] && error "stat should fail"
2569 run_test 130b "enqueue resend on a stale inode"
2572 remote_mds_nodsh && skip "remote MDS with nodsh" && return
2574 do_nodes ${CLIENTS:-$HOSTNAME} sync
2575 echo XXX > $DIR/$tfile
2577 cancel_lru_locks mdc
2579 # Trigger writeback on $tfile.
2581 # we need to race with unlink, unlink must complete before we will
2582 # take a DLM lock, otherwise unlink will wait until intent will
2583 # complete; but later than intent starts so that intent found
2585 #define OBD_FAIL_MDS_INTENT_DELAY 0x160
2586 set_nodes_failloc "$(mdts_nodes)" 0x80000160
2593 # drop the reply so that resend happens on an unlinked file.
2594 #define OBD_FAIL_MDS_LDLM_REPLY_NET 0x157
2595 set_nodes_failloc "$(mdts_nodes)" 0x80000157
2597 # let the reply to be dropped
2600 #define OBD_FAIL_SRV_ENOENT 0x217
2601 set_nodes_failloc "$(mdts_nodes)" 0x80000217
2607 run_test 130c "layout intent resend on a stale inode"
2610 local before=$(date +%s)
2613 mount_client $MOUNT2 || error "mount filed"
2616 # get a lock on client so that export would reach the stale list
2617 $SETSTRIPE -i 0 $DIR/$tfile || error "setstripe failed"
2618 dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1 conv=fsync ||
2621 #define OBD_FAIL_OST_PAUSE_PUNCH 0x236
2622 do_facet ost1 $LCTL set_param fail_val=120 fail_loc=0x80000236
2624 $TRUNCATE $DIR/$tfile 100 &
2627 dd if=/dev/zero of=$DIR2/$tfile bs=4096 count=1 conv=notrunc ||
2631 umount_client $MOUNT2
2633 evict=$(do_facet client $LCTL get_param \
2634 osc.$FSNAME-OST0000-osc-*/state |
2635 awk -F"[ [,]" '/EVICTED ]$/ { if (t<$5) {t=$5;} } END { print t }')
2637 [ -z "$evict" ] || [[ $evict -le $before ]] ||
2638 (do_facet client $LCTL get_param \
2639 osc.$FSNAME-OST0000-osc-*/state;
2640 error "eviction happened: $evict before:$before")
2642 run_test 132 "long punch"
2645 remote_ost_nodsh && skip "remote OST with nodsh" && return 0
2648 # get a lock on client so that export would reach the stale list
2649 $SETSTRIPE -i 0 $DIR/$tfile || error "setstripe failed"
2650 dd if=/dev/zero of=$DIR/$tfile count=1 || error "dd failed"
2652 # another IO under the same lock
2653 #define OBD_FAIL_OSC_DELAY_IO 0x414
2654 $LCTL set_param fail_loc=0x80000414
2655 $LCTL set_param fail_val=4 fail_loc=0x80000414
2656 dd if=/dev/zero of=$DIR/$tfile count=1 conv=notrunc oflag=dsync &
2660 #define OBD_FAIL_LDLM_BL_EVICT 0x31e
2661 set_nodes_failloc "$(osts_nodes)" 0x8000031e
2665 wait $pid && error "dd succeeded"
2668 run_test 131 "IO vs evict results to IO under staled lock"
2671 local list=$(comma_list $(mdts_nodes))
2673 local t=$((TIMEOUT * 2))
2676 flock $DIR/$tfile -c "echo bl lock;sleep $t;echo bl flock unlocked" &
2678 multiop_bg_pause $DIR/$tfile O_jc || return 1
2681 #define OBD_FAIL_LDLM_REPLY 0x30c
2682 do_nodes $list $LCTL set_param fail_loc=0x8000030c
2684 echo "waiting for multiop $PID"
2685 wait $PID || return 2
2691 run_test 133 "don't fail on flock resend"
2694 [ -z "$CLIENTS" ] && skip "Need two or more clients" && return
2695 [ $CLIENTCOUNT -lt 2 ] &&
2696 { skip "Need 2+ clients, have $CLIENTCOUNT" && return; }
2698 mkdir -p $MOUNT/$tdir/1 $MOUNT/$tdir/2 || error "mkdir failed"
2699 touch $MOUNT/$tdir/1/$tfile $MOUNT/$tdir/2/$tfile ||
2700 error "touch failed"
2701 zconf_umount_clients $CLIENTS $MOUNT
2702 zconf_mount_clients $CLIENTS $MOUNT
2704 #define OBD_FAIL_TGT_REPLY_DATA_RACE 0x722
2705 # assume commit interval is 5
2706 do_facet mds1 "$LCTL set_param fail_loc=0x722 fail_val=5"
2708 local -a clients=(${CLIENTS//,/ })
2709 local client1=${clients[0]}
2710 local client2=${clients[1]}
2712 do_node $client1 rm $MOUNT/$tdir/1/$tfile &
2714 do_node $client2 mv $MOUNT/$tdir/2/$tfile $MOUNT/$tdir/2/${tfile}_2 &
2717 wait $rmpid || error "rm failed"
2718 wait $mvpid || error "mv failed"
2721 run_test 134 "race between failover and search for reply data free slot"
2724 check_and_cleanup_lustre